=== modified file 'bzrlib/patches.py'
--- bzrlib/patches.py	2014-12-12 03:59:25 +0000
+++ bzrlib/patches.py	2015-07-02 10:37:05 +0000
@@ -358,6 +358,14 @@
 
     for line in iter_lines:
         if line.startswith('=== '):
+            if len(saved_lines) > 0:
+                if keep_dirty and len(dirty_head) > 0:
+                    yield {'saved_lines': saved_lines,
+                           'dirty_head': dirty_head}
+                    dirty_head = []
+                else:
+                    yield saved_lines
+                saved_lines = []
             dirty_head.append(line)
             continue
         if line.startswith('*** '):

=== modified file 'bzrlib/tests/test_patches.py'
--- bzrlib/tests/test_patches.py	2014-12-12 03:59:25 +0000
+++ bzrlib/tests/test_patches.py	2015-07-02 11:30:47 +0000
@@ -67,14 +67,22 @@
         lines = ["=== added directory 'foo/bar'\n",
                  "=== modified file 'orig/commands.py'\n",
                  "--- orig/commands.py\n",
-                 "+++ mod/dommands.py\n"]
+                 "+++ mod/dommands.py\n",
+                 "=== modified file 'orig/another.py'\n",
+                 "--- orig/another.py\n",
+                 "+++ mod/another.py\n"]
         patches = parse_patches(
             lines.__iter__(), allow_dirty=True, keep_dirty=True)
+        self.assertLength(2, patches)
         self.assertEqual(patches[0]['dirty_head'],
                          ["=== added directory 'foo/bar'\n",
                           "=== modified file 'orig/commands.py'\n"])
         self.assertEqual(patches[0]['patch'].get_header().splitlines(True),
                          ["--- orig/commands.py\n", "+++ mod/dommands.py\n"])
+        self.assertEqual(patches[1]['dirty_head'],
+                         ["=== modified file 'orig/another.py'\n"])
+        self.assertEqual(patches[1]['patch'].get_header().splitlines(True),
+                         ["--- orig/another.py\n", "+++ mod/another.py\n"])
 
     def testValidPatchHeader(self):
         """Parse a valid patch header"""

